package com.jasamedika.medifirst2000.vo;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.*;
import java.util.Date;
import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import com.jasamedika.medifirst2000.helper.Caption;

/**
 *  class StrukturAccount
 * 
 * @author Generator
 */
//@Entity
//@Table(name = "StrukturAccount_M")
public class StrukturAccountVO extends BaseMasterVO {
	@Caption(value="Format Account")
	private String formatAccount;

	public void setFormatAccount(String formatAccount) {
		this.formatAccount = formatAccount;
	}

	@Column(name = "FormatAccount", nullable = true , length = 15)
	public String getFormatAccount(){
		return this.formatAccount;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectHistoryLoginIFk")
	@NotNull(message="Object History Login I Harus Diisi")
	@Caption(value="Object History Login I")
	private HistoryLoginModulAplikasiVO historyLoginI;

	public void setHistoryLoginI(HistoryLoginModulAplikasiVO historyLoginI) {
		this.historyLoginI = historyLoginI;
	}

	@Column(name = "KdHistoryLoginI", nullable = false )
	public HistoryLoginModulAplikasiVO getHistoryLoginI(){
		return this.historyLoginI;
	}

	@Column(name = "ObjectHistoryLoginIFk", insertable=false,updatable=false)
	private Integer historyLoginIId;

	@ManyToOne
	@JoinColumn(name = "ObjectHistoryLoginSFk")
	@Caption(value="Object History Login S")
	private HistoryLoginModulAplikasiVO historyLoginS;

	public void setHistoryLoginS(HistoryLoginModulAplikasiVO historyLoginS) {
		this.historyLoginS = historyLoginS;
	}

	@Column(name = "KdHistoryLoginS", nullable = true )
	public HistoryLoginModulAplikasiVO getHistoryLoginS(){
		return this.historyLoginS;
	}

	@Column(name = "ObjectHistoryLoginSFk", insertable=false,updatable=false)
	private Integer historyLoginSId;

	@ManyToOne
	@JoinColumn(name = "ObjectHistoryLoginUFk")
	@Caption(value="Object History Login U")
	private HistoryLoginModulAplikasiVO historyLoginU;

	public void setHistoryLoginU(HistoryLoginModulAplikasiVO historyLoginU) {
		this.historyLoginU = historyLoginU;
	}

	@Column(name = "KdHistoryLoginU", nullable = true )
	public HistoryLoginModulAplikasiVO getHistoryLoginU(){
		return this.historyLoginU;
	}

	@Column(name = "ObjectHistoryLoginUFk", insertable=false,updatable=false)
	private Integer historyLoginUId;

	@ManyToOne
	@JoinColumn(name = "ObjectJenisAccountFk")
	@NotNull(message="Object Jenis Account Harus Diisi")
	@Caption(value="Object Jenis Account")
	private JenisAccountVO jenisAccount;

	public void setJenisAccount(JenisAccountVO jenisAccount) {
		this.jenisAccount = jenisAccount;
	}

	@Column(name = "KdJenisAccount", nullable = false )
	public JenisAccountVO getJenisAccount(){
		return this.jenisAccount;
	}

	@Column(name = "ObjectJenisAccountFk", insertable=false,updatable=false)
	private Integer jenisAccountId;

	@Caption(value="Kode Struktur Account")
	private Byte kdStrukturAccount;

	public void setKdStrukturAccount(Byte kdStrukturAccount) {
		this.kdStrukturAccount = kdStrukturAccount;
	}

	@Column(name = "KdStrukturAccount", nullable = false )
	public Byte getKdStrukturAccount(){
		return this.kdStrukturAccount;
	}

	@Caption(value="Level Account")
	private Byte levelAccount;

	public void setLevelAccount(Byte levelAccount) {
		this.levelAccount = levelAccount;
	}

	@Column(name = "LevelAccount", nullable = false )
	public Byte getLevelAccount(){
		return this.levelAccount;
	}

	@Caption(value="No Urut Akhir")
	private Byte noUrutAkhir;

	public void setNoUrutAkhir(Byte noUrutAkhir) {
		this.noUrutAkhir = noUrutAkhir;
	}

	@Column(name = "NoUrutAkhir", nullable = false )
	public Byte getNoUrutAkhir(){
		return this.noUrutAkhir;
	}

	@Caption(value="No Urut Awal")
	private Byte noUrutAwal;

	public void setNoUrutAwal(Byte noUrutAwal) {
		this.noUrutAwal = noUrutAwal;
	}

	@Column(name = "NoUrutAwal", nullable = false )
	public Byte getNoUrutAwal(){
		return this.noUrutAwal;
	}

	@Caption(value="Struktur Account")
	private String strukturAccount;

	public void setStrukturAccount(String strukturAccount) {
		this.strukturAccount = strukturAccount;
	}

	@Column(name = "StrukturAccount", nullable = false , length = 80)
	public String getStrukturAccount(){
		return this.strukturAccount;
	}

	/*//
	@OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, mappedBy = "kdstrukturaccount")
	private Set<ChartOfAccount> ChartOfAccountSet = new HashSet<ChartOfAccount>();

	public Set<ChartOfAccount> getChartOfAccountSet() {
		return ChartOfAccountSet;
	}

	public void setChartOfAccountSet(Set<ChartOfAccount> chartOfAccountSet) {
		ChartOfAccountSet = chartOfAccountSet;
	}*/
	
}

